% Joe Jupin
% Homework 3 Part 3
% Dilation Filter

% clear all variables
clear all;

% read image
Im8 = imread('noise_2.gif');
% convert to double
ImD = double(Im8);
% set image output to gray
colormap(gray);
% show unprocessed image
imshow(Im8);

% neighborhood size
% must be an odd number
neigh = 3;
% padded boader size
bdr = (neigh-1)/2;

% get size of image
[xsize ysize] = size(ImD);

% create zero padded image
ImP = zeros(xsize+2*bdr, ysize+2*bdr);
ImP(1+bdr:xsize+bdr, 1+bdr:ysize+bdr) = ImD;

% perform dilation filter
for i=1:xsize
    for j=1:ysize
        x = ImP(i:i+2*bdr, j:j+2*bdr);
        ImD(i, j) = max(max(x));
    end
end

% convert to image
Im8 = uint8(ImD);
% display image
figure, imshow(Im8);