% Joe Jupin
% Homework 3 Part 2
% Median Filter

% clear all variables
clear all;

% read image
Im8 = imread('noise_2.gif');
% convert to double
ImD = double(Im8);
% set image output to gray
colormap(gray);
% show unprocessed image
imshow(Im8);

% neighborhood size
% must be an odd number
neigh = 3;
% padded boader size
bdr = (neigh-1)/2;

% get size of image
[xsize ysize] = size(ImD);

% create zero padded image
ImP = zeros(xsize+2*bdr, ysize+2*bdr);
ImP(1+bdr:xsize+bdr, 1+bdr:ysize+bdr) = ImD;

% perform median filter
%for i=1:xsize
%    for j=1:ysize
%        x = ImP(i:i+2*bdr, j:j+2*bdr);
%        ImD(i, j) = median(median(x));
%    end
%end

% changed from above because median
% is holistic not distributive
% perform median filter
for i=1:xsize
    for j=1:ysize
        x = ImP(i:i+2*bdr, j:j+2*bdr);
        y(1:3) = x(1:3);
        y(4:6) = x(4:6);
        y(7:9) = x(7:9);
        ImD(i, j) = median(median(y));
    end
end

% convert to image
Im8 = uint8(ImD);
% display image
figure, imshow(Im8);